<?php
/*****************************************************************************\
###############################################################################
#                                                                             #
#   dueTasks.php : A script to email due Tasks.                               #
#                  Work with TaskFreak 0.6.2 & EmailNotify 0.1.7              #
#                                                                             #
#   +---------------------------------------------------------------------+   #
#   | Copyright (c) 2010 Flyounet                                         |   #
#   +---------------------------------------------------------------------+   #
#   | This program is free software: you can redistribute it and/or       |   #
#   | modify it under the terms of the GNU General Public License as      |   #
#   | published by the Free Software Foundation, either version 3 of the  |   #
#   | License, or (at your option) any later version.                     |   #
#   |                                                                     |   #
#   | This program is distributed in the hope that it will be useful,     |   #
#   | but WITHOUT ANY WARRANTY; without even the implied warranty of      |   #
#   | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       |   #
#   | GNU General Public License for more details.                        |   #
#   |                                                                     |   #
#   | You should have received a copy of the GNU General Public License   |   #
#   | along with this program.                                            |   #
#   | If not, see <http://www.gnu.org/licenses/>.                         |   #
#   +---------------------------------------------------------------------+   #
#   | Cette œuvre est distribuée SANS AUCUNE GARANTIE hormis celle d'être |   #
#   | distribuée sous les termes de la License Demerdez-vous ("Demerden   |   #
#   | Sie Sich License") plus communément appelée DSSL telle que publiée  |   #
#   | par Flyounet : soit la version 1 de cette licence, soit (à votre    |   #
#   | gré) toute version ultérieure.                                      |   #
#   |                                                                     |   #
#   | Vous devriez avoir reçu une copie de la Licence Démerdez-vous avec  |   #
#   | cette œuvre ; si ce n’est pas le cas, consultez :                   |   #
#   | <http://dssl.flyounet.net/licenses/>.                               |   #
#   +---------------------------------------------------------------------+   #
#   | Author: Flyounet  < dev @@ flyounet . net >                         |   #
#   +---------------------------------------------------------------------+   #
#                                                                             #
###############################################################################
#                                                                             #
# v0.01 [12/05/2010] Flyounet  [@Home] :                                      #
#       > Initiale Release                                                    #
#                                                                             #
#                                                                             #
#                                                                             #
#                                                                             #
###############################################################################
#                                                                             #
# Todo :                                                                      #
# < Manage tasks that have been terminated and changed to be done.            #
#                                                                             #
#                                                                             #
###############################################################################
#                                                                             #
# Legende :                                                                   #
#  + --> Indique une nouveaute, un ajout de fonctionnalite.                   #
#  * --> Indique une correction de bogue.                                     #
#  - --> Indique la suppression d'une fonctionnalite/variable.                #
#  > --> Indique une information n'ayant pas forcement de rapport avec le code#
#  < --> Indique une amelioration a apporter au code.                         #
# <- --> Indique une amelioration en cours de developpement/realisation.      #
# OK --> Indique qu'une amelioration a ete effectuee.                         #
#                                                                             #
###############################################################################
\*****************************************************************************/

/* Request to execute :
SELECT
 b.itemId, a.title, a.deadlineDate, b.statusKey
FROM
 frk_item a, frk_itemStatus b, frk_member c
WHERE
 a.deadlineDate < '2010-05-12' and
 b.statusKey<5 and
 b.statusKey=(select MAX(statusKey) from frk_itemStatus where itemId=b.itemId limit 1) and
 b.itemId=a.itemId and
 (a.memberId=c.memberId or a.authorId=c.memberId) 
GROUP BY
 itemId,statusKey 
ORDER BY
 a.deadlineDate ASC
*/


# ############################################################################ #
# Variables Initialisation
# ############################################################################ #
require('_include.php');
include_once(PRJ_CLASS_PATH.'tzn_generic.php');
include_once(PRJ_CLASS_PATH.TZN_DB_CLASS);
include_once(PRJ_CLASS_PATH.'tzn_user.php');
include_once(PRJ_CLASS_PATH.'pkg_member.php');
include_once(PRJ_CLASS_PATH.'pkg_project.php');
include_once(PLG_EMAIL_DIR.'include/Notify.php');

$objDb       = new TznDbConnection();
$db          = $objDb->connect();
$objItemList = new ItemStats();
$objAuthor   = new Member();

$_dateOfDay  = date('Y-m-d');

# ############################################################################ #
# Functions
# ############################################################################ #

#Fxx.01.01
#Function : date_diff, Check the number of day between 2 dates
#Syntaxe  : date_diff(date1, date2)
#Return   : integer
#Notes    : function doesn't if date1 > date2 or not.
function date_diff($date1, $date2) {
	if ($date1 > $date2) {
		$current=$date2;
		$datetime2 = date_create($date1);
	} else {
		$current = $date1;
		$datetime2 = date_create($date2);
	}
	$count = 0;
	while (date_create($current) < $datetime2) {
		$current = gmdate("Y-m-d", strtotime("+1 day", strtotime($current)));
		$count++;
	}
	# If you have PHP>5.3, use the command bellow and comment all above
	# $datetime1 = new DateTime($date1);
	# $datetime2 = new DateTime($date2);
	# $count = date_diff($datetime1, $datetime2);
	return($count);
} 

# ############################################################################ #
# Main
# ############################################################################ #

if (!$db) {
	print 'Can\'t connect to Database ! ('.$objDb->_error['db'].')';
	exit(1);
}

# Generate the request
$objItemList->addWhere('ii.deadlineDate < \''.$_dateOfDay.'\'');
$objItemList->addWhere('iis.statusKey < 5');
$objItemList->addWhere('statusKey=(select MAX(statusKey) from frk_itemStatus where itemId=iis.itemId limit 1)');
$objItemList->addWhere('iis.itemId=ii.itemId');
$objItemList->addWhere('(ii.memberId=mm.memberId OR ii.authorId=mm.memberId)');
# The two line bellow, only to sent email to me for testing
$objItemList->addWhere('ii.memberId=2');
$objItemList->addWhere('ii.authorId=2');
$objItemList->addGroup('iis.itemId,iis.statusKey');
$objItemList->addOrder('ii.deadlineDate ASC');
# Load/Execute request
$objItemList->loadList();
# Something to do ?
if ($objItemList->rMore()) {
	print "\n\nCount: ".$objItemList->rCount().' - Total: '.$objItemList->rTotal()."\n\n";
	while ($objItem = $objItemList->rNext()) {
		$interval=date_diff($_dateOfDay, $objItem->deadlineDate);
		# Only with PHP>5.3
		# print $interval->format('%R%d days')."\n";
		# $interval=$interval->format('%d');
		
		# Line bellow, for test only
		print 'id: '.$objItem->id.' - titre: '.$objItem->title.' - deadline: '.$objItem->deadlineDate.' - status: '.(20*$objItem->itemStatus->statusKey)."%\n";

		# Call the email function
		$objAuthor->setUid($objItem->authorId);
		$objAuthor->load();
		Send_Email_Notify($objItem, $objAuthor, 6, $objItem->project, $interval);
		# Don't want to flood
		sleep(2);	
		#print "\n\n".print_r($objItem)."\n\n";
	}
}
exit(0);
?>
